#include "stdafx.h"
#include "ActionStatusUpdater.h"



CppRuby::Object
Wrap_ActionStatusUpdater( CCmdUI *commandUi )
{
  return Data_Wrap_Struct( CppRuby::Klass( "ActionStatusUpdater" ),
                           NULL,
                           NULL,
                           commandUi );
}




static VALUE
ActionStatusUpdater_Enable( VALUE self, VALUE enabled )
{
  CCmdUI *commandUi;
  Data_Get_Struct( self, CCmdUI, commandUi );
  commandUi->Enable( !(enabled == Qfalse  ||  enabled == Qnil) );
  return Qnil;
}


static VALUE
ActionStatusUpdater_Check( VALUE self, VALUE check )
{
  CCmdUI *commandUi;
  Data_Get_Struct( self, CCmdUI, commandUi );
  int checkValue;
  if ( check == Qfalse )
    checkValue = 0; // unchecked
  else if ( check == Qnil )
    checkValue = 2; // undefined
  else
    checkValue = 1; // checked

  commandUi->SetCheck( checkValue );
  return Qnil;
}



static VALUE
ActionStatusUpdater_Text( VALUE self, VALUE text )
{
  CCmdUI *commandUi;
  Data_Get_Struct( self, CCmdUI, commandUi );
  commandUi->SetText( STR2CSTR( text ) );
  return Qnil;
}



void 
Init_ActionStatusUpdater()
{
  CppRuby::Klass klass( "ActionStatusUpdater" );
  ruby_define_method( klass, "enable=", ActionStatusUpdater_Enable, 1 );
  ruby_define_method( klass, "check=", ActionStatusUpdater_Check, 1 );
  ruby_define_method( klass, "text=", ActionStatusUpdater_Text, 1 );
}
