#include "stdafx.h"
#include "EditorFrame.h"
#include "MainFrame.h"
#include "RubyExtMainFrame.h"
#include "RubyTools.h"


static VALUE
MainFrame_DoNewEditorWindow( VALUE self )
{
  EditorFrame *frame = MainFrame::instance().newEditorWindow();
  if ( frame )
    return frame->view().editor();
  return Qnil;
}


void 
Init_MainFrame()
{
  rb_require( "MainFrame.rb" );
  ruby_define_method( ruby_get_class( "MainFrame" ), 
                      "doNewEditorWindow",
                      MainFrame_DoNewEditorWindow,
                      0 );
}