#ifndef PRATICALRUBY_COLOR_H
#define PRATICALRUBY_COLOR_H

namespace Color
{
/*
    Black  = #000000    Green  = #008000
    Silver = #C0C0C0    Lime   = #00FF00
    Gray   = #808080    Olive  = #808000
    White  = #FFFFFF    Yellow = #FFFF00
    Maroon = #800000    Navy   = #000080
    Red    = #FF0000    Blue   = #0000FF
    Purple = #800080    Teal   = #008080
    Fuchsia= #FF00FF    Aqua   = #00FFFF
*/

const COLORREF black    = RGB(   0,   0,   0 );
const COLORREF silver   = RGB( 192, 192, 192 );
const COLORREF gray     = RGB( 128, 128, 128 );
const COLORREF white    = RGB( 255, 255, 255 );
const COLORREF maroon   = RGB( 128,   0,   0 );
const COLORREF red      = RGB( 255,   0,   0 );
const COLORREF purple   = RGB( 128,   0, 128 );
const COLORREF fuchsia  = RGB( 255,   0, 255 );
const COLORREF green    = RGB(   0, 128,   0 );
const COLORREF lime     = RGB(   0, 255,   0 );
const COLORREF olive    = RGB( 128, 128,   0 );
const COLORREF yellow   = RGB( 255, 255,   0 );
const COLORREF navy     = RGB(   0,   0, 128 );
const COLORREF blue     = RGB(   0,   0, 255 );
const COLORREF teal     = RGB(   0, 128, 128 );
const COLORREF aqua     = RGB(   0, 255, 255 );

const COLORREF aquaBlue     = RGB(   0, 128, 192 );
const COLORREF offWhite = RGB( 255, 251, 240 );


 

}  // namespace Color

#endif