// EditorFrame.h : interface of the EditorFrame class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_EDITORFRAME_H__36DCC1A9_AC29_47A2_BCD4_DF7D4D552464__INCLUDED_)
#define AFX_EDITORFRAME_H__36DCC1A9_AC29_47A2_BCD4_DF7D4D552464__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "EditorView.h"
class MainFrame;



class EditorFrame : public CMDIChildWnd
{
  DECLARE_DYNCREATE(EditorFrame)
public:
  EditorFrame();
  virtual ~EditorFrame();

  MainFrame &mainFrame();
  EditorView &view();

  void updateTitle( const char *title );

// Overrides
  // ClassWizard generated virtual function overrides
  //{{AFX_VIRTUAL(EditorFrame)
  public:
  virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
  virtual void ActivateFrame(int nCmdShow);
  virtual BOOL OnCmdMsg(UINT nID, int nCode, void* pExtra, AFX_CMDHANDLERINFO* pHandlerInfo);
  protected:
  virtual BOOL OnNotify(WPARAM wParam, LPARAM lParam, LRESULT* pResult);
  //}}AFX_VIRTUAL

public:
#ifdef _DEBUG
  virtual void AssertValid() const;
  virtual void Dump(CDumpContext& dc) const;
#endif

// Generated message map functions
protected:
  //{{AFX_MSG(EditorFrame)
  afx_msg void OnFileClose();
  afx_msg void OnSetFocus(CWnd* pOldWnd);
  afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
  afx_msg void OnChildActivate();
	afx_msg void OnClose();
	//}}AFX_MSG
  DECLARE_MESSAGE_MAP()

private:

  EditorView m_wndView;
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_EDITORFRAME_H__36DCC1A9_AC29_47A2_BCD4_DF7D4D552464__INCLUDED_)
