#include "stdafx.h"
#include "resource.h"
#include "CppRuby.h"
#include "RubyExtDialog.h"
#include "FindDialog.h"



VALUE
Dialog_DoFindDialog( VALUE self,
                     VALUE text )
{
  FindDialog dialog;
  if ( text != Qnil )
    dialog.m_strFindWhat = STR2CSTR( text );
  if ( dialog.DoModal() != IDOK )
    return Qnil;

  return rb_str_new2( (LPCTSTR)dialog.m_strFindWhat );
}


VALUE
Dialog_DoMessageDialog( VALUE self,
                        VALUE message )
{
  ::AfxMessageBox( STR2CSTR( message ) );
  return Qnil;
}


void 
Init_Dialog()
{
  rb_require( "Dialog.rb" );
  ruby_define_module_function( ruby_get_class("Dialog"),
                               "doFindDialog",
                               Dialog_DoFindDialog, 1 );
  ruby_define_module_function( ruby_get_class("Dialog"),
                               "doMessageDialog",
                               Dialog_DoMessageDialog, 1 );
}
