#ifndef RUBY_EXT_SCINTILLA_H
#define RUBY_EXT_SCINTILLA_H

#include <ruby.h>
#include <Scintilla.h>

extern "C" {

extern void Init_Scintilla();

extern void *Get_Scintilla_Window_Handle( VALUE editor );

// Create a wrapped ruby object for notification and call
// scintillaEvent( notification ) on target object
extern void Scintilla_Forward_Notification( SCNotification *notification, 
                                            VALUE target );
extern VALUE ruby_cScintillaBridge;

}


#endif